<template>
  <div class="container-fluid">
    <!-- start page title -->
    <div class="row">
      <div class="col-12">
        <div class="page-title-box">
          <h4 class="page-title">
            Загрузка товаров
          </h4>
        </div>
      </div>
    </div>
    <!-- end page title -->
    <div class="card-box">
      <div class="row">
        <div class="col-12">
          <div class="card">
            <div class="card-body">
              <div class="row mb-2">
                <div class="col-sm-3">
                  <input type="file" ref="file" class="custom-file-input" id="inputGroupFile04" accept="application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel" @change="handleFileUpload()" />
                  <label class="custom-file-label" for="inputGroupFile04">Выберите файл</label>
                </div>
                <div class="col-sm-2">
                  <button class="btn btn-primary btn-block" @click.prevent="submitFile()" :disabled="isDisabled"> Загрузить </button>
                </div>
                <div class="col-sm-7">
                  <div class="text-sm-right">
                    <button type="button" class="btn btn-light mb-2 mr-1"><a href="/assets/data/template.xlsx">Скачать шаблон</a></button>
                  </div>
                </div><!-- end col-->
              </div>
              <div class="progress mb-2" v-show="showProgress">
                <div class="progress-bar progress-bar-striped progress-bar-animated" role="progressbar" aria-valuenow="75" aria-valuemin="0" aria-valuemax="100" :style="{'width': this.progress + '%'}"></div>
              </div>
            </div>
            <div class="card-body">
              <p>Для дальнейшей работы с сайтом загрузите каталог товаров. Для этого скачайте и заполните шаблон согласно описанию полей (см. ниже). Файл должен быть в формате <strong>XLSX</strong>.</p>
              <p>Для загрузки проделайте следующие шаги:</p>
              <h5>Шаг 1. Скачайте шаблон</h5>
              <h5>Шаг 2. Добавьте в шаблон ваши товары</h5>
              <p>Первые четыре строки с товарами заполнены для примера. Отредактируйте их, указав свои товары.</p>
              <div class="col-xl-6">
                <div class="accordion custom-accordion" id="custom-accordion-one">
                  <div class="card mb-0">
                    <div class="card-header" id="headingNine">
                      <h5 class="m-0 position-relative">
                        <a class="custom-accordion-title text-reset d-block"
                           data-toggle="collapse" href="#collapseNine"
                           aria-expanded="true" aria-controls="collapseNine">
                          Описание полей <i
                          class="mdi mdi-chevron-down accordion-arrow"></i>
                        </a>
                      </h5>
                    </div>

                    <div id="collapseNine" class="collapse show"
                         aria-labelledby="headingFour"
                         data-parent="#custom-accordion-one">
                      <div class="card-body">
                        <div class="table-responsive">
                          <table class="table mb-0">
                            <thead class="thead-light">
                            <tr>
                              <th>Поле</th>
                              <th>Описание</th>
                              <th>Обязательность</th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr>
                              <td>Баркод</td>
                              <td>Уникальный код для единицы товара. Например, для футболки красного цвета 40 размера.</td>
                              <td>Необязательное</td>
                            </tr>
                            <tr>
                              <td>Артикул (SKU)</td>
                              <td>Уникальный артикул для товара. Для одного наименования товара одного цвета должен быть уникальный артикул.</td>
                              <td>Обязательное</td>
                            </tr>
                            <tr>
                              <td>Наименование товара</td>
                              <td>Наименование товара, которое будет отбражаться в карточке товара.</td>
                              <td>Обязательное</td>
                            </tr>
                            <tr>
                              <td>Описание</td>
                              <td>Описание товара. Может содержать дополнительную информацию о товаре.</td>
                              <td>Необязательное</td>
                            </tr>
                            <tr>
                              <td>Модель</td>
                              <td>Модель товара. Может содержать дополнительную информацию о товаре.</td>
                              <td>Необязательное</td>
                            </tr>
                            <tr>
                              <td>Страна производства</td>
                              <td>Страна, в которой был произведен товар. Например, Россия.</td>
                              <td>Необязательное</td>
                            </tr>
                            <tr>
                              <td>Базовая оптовая цена</td>
                              <td>Оптовая цена, по которой отпускает товар оптом.</td>
                              <td>Обязательное</td>
                            </tr>
                            <tr>
                              <td>Цена со скидкой</td>
                              <td>Оптовая цена со скидкой.</td>
                              <td>Необязательное</td>
                            </tr>
                            <tr>
                              <td>Цена по акции</td>
                              <td>Оптовая цена по акции.</td>
                              <td>Необязательное</td>
                            </tr>
                            <tr>
                              <td>РРЦ</td>
                              <td>Рекомендованная розничная цена. Показывается по умолчанию для тех, кто не является вашим покупателем.</td>
                              <td>Обязательное</td>
                            </tr>
                            <tr>
                              <td>Базовая категория</td>
                              <td>Базовая категория предлагаемых товаров, например: Женская одежда. Для точного определения категории, выберите базовую категорию из списка ниже.</td>
                              <td>Обязательное</td>
                            </tr>
                            <tr>
                              <td>Категория товара</td>
                              <td>Категория товара наиболее низкого уровня, например: Женская футболка. Для точного определения категории, после выбора базовой категории найдите наиболее близкую категорию к товару. Если Вы не нашли категорию своего товара, <NuxtLink to="/contacts">сообщите нам</NuxtLink>.</td>
                              <td>Обязательное</td>
                            </tr>
                            <tr>
                              <td>Тип категории товара</td>
                              <td>Возможны варианты:
                                  <ul>
                                    <li>woman-shoes - Женская обувь</li>
                                    <li>woman-clothes - Женская одежда</li>
                                    <li>woman-dresses - Женские платья</li>
                                    <li>woman-underwear-brassiere - Бюстгалтер</li>
                                    <li>mans-shoes - Мужская обувь</li>
                                    <li>mans-jeans - Мужские джинсы</li>
                                    <li>mans-clothes - Мужская одежда</li>
                                    <li>woman-socks - Женские носки</li>
                                  </ul>
                              </td>
                              <td>Обязательное</td>
                            </tr>
                            <tr>
                              <td>Характеристики</td>
                              <td>
                                <p>Укажите параметры товара в формате:<br/>
                                параметр X | значение X;
                                параметр Y | значение Y;</p>

                                <p>После каждого параметра поставьте точку с запятой. Последняя точка с запятой не обязательна.</p>
                                <p>Название параметра и значение разделите вертикальной чертой |. Обязательно указывать только название.</p>
                                <p>Наличие остатка обязально.</p>

                                <p>Пример:<br/>
                                Цвет|Белый;Размер|39;Остаток|10</p>
                              </td>
                              <td>Обязательное</td>
                            </tr>
                            <tr>
                              <td>Статус</td>
                              <td><p>Статус товара. Если не указано, то по-умолчанию будет статус "Скрыто".</p>
                                    Возможные варианты:
                                    <ul>
                                      <li>Новинка</li>
                                      <li>Черновик</li>
                                  <li>Активно</li>
                                  <li>Не активно</li>
                                  <li>Недоступно</li>
                                  <li>Акция</li>
                                  <li>Скрыто</li>
                                  <li>Удалено</li>
                                  <li>Рекомендуемый</li>
                                  <li>Ожидается в повторе</li>
                                  <li>Предзаказ</li>
                                    </ul>
                              </td>
                              <td>Необязательное</td>
                            </tr>
                            <tr>
                              <td>Единица измерения</td>
                              <td>Единица измерения товара. Например, шт., гр., т.д.</td>
                              <td>Необязательное</td>
                            </tr>
                            <tr>
                              <td>Коллекция</td>
                              <td>Коллекция товара, если товар содержится в коллекции.</td>
                              <td>Необязательное</td>
                            </tr>
                            <tr>
                              <td>Сезон</td>
                              <td>Сезонность товара. Например, Лето. </td>
                              <td>Необязательное</td>
                            </tr>
                            <tr>
                              <td>Сегмент</td>
                              <td>Сегмент товара. Например, эконом. Доступные варианты:
                                <ul>
                                  <li>Эконом</li>
                                  <li>Средний</li>
                                  <li>Высокий</li>
                                  <li>Премиум</li>
                                </ul>
                              </td>
                              <td>Обязательное</td>
                            </tr>
                            <tr>
                              <td>Состав</td>
                              <td>Описание из каких материалов состоит товар.</td>
                              <td>Необязательное</td>
                            </tr>
                            <tr>
                              <td>Изображения</td>
                              <td>
                                <p>URL-ссылка на картинку товара.</p>

                                <p>Требования к ссылкам</p>

                                <ul>
                                  <li>Допустимые протоколы URL изображения — HTTP или HTTPS.</li>
                                  <li>Ссылка на изображение должна быть абсолютной. Относительные ссылки недопустимы.</li>
                                  <li>По указанной ссылке должно размещаться изображение товара, соответствующего описанию
                                    предложения. Нельзя использовать изображение другого товара.
                                  </li>
                                  <li>Запрещено использовать ссылку на одно и то же изображение в описании разных товаров.
                                    Исключение — модификации одной модели, которые внешне не отличаются, например, Apple
                                    iPhone 6 Silver 16 GB и Apple iPhone 6 Silver 32 GB.
                                  </li>
                                  <li>Недопустима ссылка на HTML-страницу, содержащую изображение.</li>
                                  <li>Недопустима ссылка на логотип магазина или «заглушку» (страницу, где написано «картинка
                                    отсутствует» и т. п.).
                                  </li>
                                  <li>Максимальная длина URL — 512 символов.</li>
                                  <li>URL‑адрес формируется на основе стандарта <a href="https://tools.ietf.org/html/rfc3986" target="_blank">RFC 3986</a>.</li>
                                </ul>
                              </td>
                              <td>Необязательное</td>
                            </tr>
                            </tbody>
                          </table>
                        </div> <!-- end table-responsive-->
                      </div>
                    </div>
                  </div>
                </div>
              </div>

              <p>Доступные категории можно посмотреть в выпадающих списках. Сперва выберите Базовую категорию, а затем выберите категорию товара.</p>

              <div class="form-group mb-3">
                <label for="product-category">Базовая категория <span class="text-danger">*</span></label>
                <multiselect
                  v-model="selected"
                  :options="baseCategories"
                  :multiple="false"
                  :close-on-select="true"
                  :clear-on-select="true"
                  :preserve-search="true"
                  select-label="Нажмите для выбора"
                  selected-label="Выбрано"
                  deselect-label="Нажмите для удаления"
                  placeholder="Выберите базовую категорию"
                  label="name"
                  track-by="id"
                  :preselect-first="false"
                />
              </div>

              <div class="form-group mb-3">
                <label for="product-category">Категория товара <span class="text-danger">*</span></label>
                <multiselect
                  v-model="selectedCategory"
                  :options="filteredProducts"
                  :multiple="false"
                  :close-on-select="true"
                  :clear-on-select="true"
                  :preserve-search="true"
                  select-label="Нажмите для выбора"
                  selected-label="Выбрано"
                  deselect-label="Нажмите для удаления"
                  placeholder="Выберите базовую категорию"
                  label="name"
                  track-by="id"
                  :preselect-first="false"
                />
              </div>

              <p>Вставьте выбранные категории в соответсвующие столбцы для товара.<br/>
                Базовая категория: <span v-if="selected !== null">{{selected.name}}</span> <span v-else>Базовая категория не выбрана</span><br/>
                Категория товара: <span v-if="selectedCategory !== null">{{selectedCategory.name}}</span> <span v-else>Категория товара не выбрана</span></p>

              <h5>Шаг 3. Загрузите файл</h5>
              <p>Выберите созданный файл и загрузите, нажав на кнопку «Загрузить» вверху этой страницы</p>

              <h5>Дополнительная информация</h5>
              <p>Требования</p>
              <ul>
                <li>Файл должен иметь расширение <strong>.xlsx</strong>, т.е.&nbsp;быть сохранен в&nbsp;формте Excel 2007-365</li>
                <li>Столбцы должны располагаться точно так же, как в шаблоне.</li>
                <li>По&nbsp;ссылкам на картинки должны быть доступны фото в&nbsp;открытом доступе</li>
                <li>Для обновления товаров просто загрузите файл с&nbsp;Артикулами товаров, которые уже есть в&nbsp;базе</li>
              </ul>

            </div>
          </div>
          <div>

          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
    export default {
        name: "upload",
        data(){
          return {
            file: '',
            showProgress: false,
            isDisabled: false,
            uploadData: {
              startRow: 2,
              total: 0,
              file: '',
            },
            progress: 0,
            pageData: {},
            currentItem: {},
            selected: 0,
            items: [],
            baseCategories: [],
            selectedCategory: 0,
            currentSelectedCategory: {},
          }
        },
      computed: {
        filteredProducts: function() {
          this.getCurrentCategory();
          this.items = [];
          this.isCategoryEmpty = true;

          for(let item in this.pageData){
            if(this.pageData[item]._lft > this.currentItem._lft && this.currentItem._rgt > this.pageData[item]._rgt){
              if(this.pageData[item]._rgt - this.pageData[item]._lft == 1){
                this.items.push(this.pageData[item]);
              }
            }
          }

          if(this.items.length == 0)
            this.items.push(this.currentItem);

          return this.items;
        }
      },

        methods: {
          getProgress(data){
            this.uploadData.total = data.data.total;
            this.uploadData.startRow = data.data.startRow;
            this.uploadData.file = data.data.file;
            this.progress = Math.round(this.uploadData.startRow / this.uploadData.total * 100);
            console.log(this.uploadData.startRow);
            if(this.progress < 100){
              this.$axios.post( '/products/upload',
                this.uploadData
              ).then(resp => {
                this.getProgress(resp);
              })
                .catch(function(){
                  console.log('FAILURE!!');
                });
            }else{
              this.$router.push('/products');
            }
          },
          handleFileUpload(){
            this.file = this.$refs.file.files[0];
            this.isDisabled = false;
          },
          submitFile(){
            this.uploadData.startRow = 2;
            this.uploadData.total = 0;
            this.progress = 0;
            this.showProgress = true;
            this.isDisabled = true;

            let formData = new FormData();
            formData.append('file', this.file);
            formData.append('startRow', this.uploadData.startRow);
            this.$axios.post( '/products/upload',
              formData,
              {
                headers: {
                  'Content-Type': 'multipart/form-data',
                },
                'credentials': "include"
              }
            ).then(resp => {
              this.getProgress(resp);
              this.files = [];
            })
              .catch(function(){
                console.log('FAILURE!!');
              });
          },
          getPageData(){
            this.$axios.get('/category/list')
              .then(resp => {
                this.pageData = resp.data;
                this.getBaseCategories();
              })
              .catch(Error => function(){
                console.log(Error)
              });
          },
          getCurrentCategory(){
            for(let item in this.pageData){
              if(this.selected !== null && this.pageData[item].id == this.selected.id){
                this.currentItem = this.pageData[item];
              }
            }
          },
          getCurrentSelectedCategory(){
            for(let item in this.pageData.categories){
              if(this.pageData[item].id == this.selectedCategory){
                this.currentSelectedCategory = this.pageData[item];
              }
            }
          },
          getBaseCategories(){
            this.baseCategories = [];
            for(let item in this.pageData){
              if(this.pageData[item].depth <= 3){
                this.baseCategories.push(this.pageData[item]);
              }
            }
            console.log(this.pageData);
          },
      },
      mounted: function(){
        this.getPageData();
        // Select2
        //$('.select2').select2();
      }
    }
</script>

<style scoped>

</style>
